javax.servlet

## Class AsyncEvent

- java.lang.Object
- - javax.servlet.AsyncEvent

-     public class AsyncEvent
      extends Object

  Event that gets fired when the asynchronous operation initiated on a ServletRequest (via a call to `ServletRequest.startAsync()` or `ServletRequest.startAsync(ServletRequest, ServletResponse)`) has completed, timed out, or produced an error.
  Since:
    Servlet 3.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncEvent(AsyncContext context)` Constructs an AsyncEvent from the given AsyncContext.
    `AsyncEvent(AsyncContext context, ServletRequest request, ServletResponse response)` Constructs an AsyncEvent from the given AsyncContext, ServletRequest, and ServletResponse.
    `AsyncEvent(AsyncContext context, ServletRequest request, ServletResponse response, Throwable throwable)` Constructs an AsyncEvent from the given AsyncContext, ServletRequest, ServletResponse, and Throwable.
    `AsyncEvent(AsyncContext context, Throwable throwable)` Constructs an AsyncEvent from the given AsyncContext and Throwable.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AsyncContext` | `getAsyncContext()` Gets the AsyncContext from this AsyncEvent.
    `ServletRequest` | `getSuppliedRequest()` Gets the ServletRequest from this AsyncEvent.
    `ServletResponse` | `getSuppliedResponse()` Gets the ServletResponse from this AsyncEvent.
    `Throwable` | `getThrowable()` Gets the Throwable from this AsyncEvent.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AsyncEvent

          public AsyncEvent(AsyncContext context)

      Constructs an AsyncEvent from the given AsyncContext.
      Parameters:
        `context` - the AsyncContex to be delivered with this AsyncEvent

    - #### AsyncEvent

          public AsyncEvent(AsyncContext context,
                    ServletRequest request,
                    ServletResponse response)

      Constructs an AsyncEvent from the given AsyncContext, ServletRequest, and ServletResponse.
      Parameters:
        `context` - the AsyncContex to be delivered with this AsyncEvent
        `request` - the ServletRequest to be delivered with this AsyncEvent
        `response` - the ServletResponse to be delivered with this AsyncEvent

    - #### AsyncEvent

          public AsyncEvent(AsyncContext context,
                    Throwable throwable)

      Constructs an AsyncEvent from the given AsyncContext and Throwable.
      Parameters:
        `context` - the AsyncContex to be delivered with this AsyncEvent
        `throwable` - the Throwable to be delivered with this AsyncEvent

    - #### AsyncEvent

          public AsyncEvent(AsyncContext context,
                    ServletRequest request,
                    ServletResponse response,
                    Throwable throwable)

      Constructs an AsyncEvent from the given AsyncContext, ServletRequest, ServletResponse, and Throwable.
      Parameters:
        `context` - the AsyncContex to be delivered with this AsyncEvent
        `request` - the ServletRequest to be delivered with this AsyncEvent
        `response` - the ServletResponse to be delivered with this AsyncEvent
        `throwable` - the Throwable to be delivered with this AsyncEvent

  - ### Method Detail

    - #### getAsyncContext

          public AsyncContext getAsyncContext()

      Gets the AsyncContext from this AsyncEvent.
      Returns:
        the AsyncContext that was used to initialize this AsyncEvent

    - #### getSuppliedRequest

          public ServletRequest getSuppliedRequest()

      Gets the ServletRequest from this AsyncEvent.

      If the AsyncListener to which this AsyncEvent is being delivered was added using `AsyncContext.addListener(AsyncListener, ServletRequest, ServletResponse)`, the returned ServletRequest will be the same as the one supplied to the above method. If the AsyncListener was added via `AsyncContext.addListener(AsyncListener)`, this method must return null.

      Returns:
        the ServletRequest that was used to initialize this AsyncEvent, or null if this AsyncEvent was initialized without any ServletRequest

    - #### getSuppliedResponse

          public ServletResponse getSuppliedResponse()

      Gets the ServletResponse from this AsyncEvent.

      If the AsyncListener to which this AsyncEvent is being delivered was added using `AsyncContext.addListener(AsyncListener, ServletRequest, ServletResponse)`, the returned ServletResponse will be the same as the one supplied to the above method. If the AsyncListener was added via `AsyncContext.addListener(AsyncListener)`, this method must return null.

      Returns:
        the ServletResponse that was used to initialize this AsyncEvent, or null if this AsyncEvent was initialized without any ServletResponse

    - #### getThrowable

          public Throwable getThrowable()

      Gets the Throwable from this AsyncEvent.
      Returns:
        the Throwable that was used to initialize this AsyncEvent, or null if this AsyncEvent was initialized without any Throwable

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.